<?php 
get_header();
?>
<!-- START HOME SECTION -->
<section id="home" class="parallax">
    <div class="home-wrapper">
        <div class="home-content">
            
            <div id="home-slider" class="slide slider-text">
               <img src="<?php echo ot_get_option('logo_home'); ?>" alt="<?php bloginfo('name'); ?>"/>   
            </div><!--/.testimonials -->

            <a href="#about" class="scroll home-btn"></a>

        </div><!--/.home-content-->
    </div><!--/.home-wrapper-->
</section>
<!-- END HOME SECTION -->




<!-- START ABOUT SECTION -->
<section id="about" class="section">
    <div class="container">

		<?php			
			$args=array(
			  'name' => 'about',
			  'post_type' => 'page'			  
			);
			$about = new WP_Query( $args );			
		?>
		<?php while ( $about->have_posts() ) : $about->the_post(); ?>
			 <div class="span12"><?php the_content(); ?></div>
		<?php endwhile;wp_reset_postdata(); ?>
		
		
    </div><!--/.container -->
</section>
<!-- END ABOUT SECTION -->


<!-- START PORTFOLIO SECTION -->
<section id="portfolio" class="section border_top">

    <div class="container">
        <div class="titles">           
            <h1>PORTFOLIO</h1>
        </div><!--/.titles -->

        <ul id="filtrable">
			<?php 

				$args1 = array(
					'type'                     => 'portfolio',
					'child_of'                 => 0,
					'parent'                   => 0,
					'orderby'                  => 'id',
					'order'                    => 'ASC',
					'hide_empty'               => 0,
					'hierarchical'             => 0,
					'exclude'                  => '',
					'include'                  => '',
					'number'                   => '',
					'taxonomy'                 => 'portfolio-category',
					'pad_counts'               => false 
				); 
				$categories = get_categories( $args1 );
				

			?>

			<?php foreach($categories as $v){ 	?>
				<li class="filter_<?php echo $v->slug ?>">
					<a href="#" data-categories="<?php echo $v->slug ?>"><?php echo $v->name ?></a>
				</li>
			<?php } ?>
         
        </ul><!--/#filtrable-->
    </div><!--/.container -->

    <div id="portfolio-items" class="portfolio-items">

		<?php
			$args=array(
				'post_type'=>'portfolio',				
				'orderby' => 'ID',
				'order' => 'desc',
				'posts_per_page'=>-1
			);
			$porfolio = new WP_Query($args);
			if ( $porfolio->have_posts() ) {	
				while ( $porfolio->have_posts() ) : $porfolio->the_post();
				$terms_current = wp_get_object_terms( get_the_ID(), 'portfolio-category' );
				
		?>
		 <article class="cate_<?php echo $terms_current[0]->slug ?>" data-categories="<?php echo $terms_current[0]->slug ?>">
            <a href="#!porfolio/<?php echo $post->post_name ?>">   
                <?php the_post_thumbnail('list_thumb');?>
                <p><span class="icon-porfolio-item"></span><?php the_title();?></p>
            </a>
        </article><!--/article-->
		
		<?php endwhile;}wp_reset_postdata(); ?>
       


    </div><!--/.portfolio-items -->

</section>
<!-- END PORTFOLIO SECTION  -->




<!-- START CONTACT PAGE -->
<section id="contact" class="section gray">
    <div class="container"> 
		<?php			
			$args=array(
			  'name' => 'contact',
			  'post_type' => 'page'			  
			);
			$contact = new WP_Query( $args );			
		?>
		<?php while ( $contact->have_posts() ) : $contact->the_post(); ?>
			
			<div class="titles">
				<i class="icon"></i>
				<h1><?php the_title()?></h1>
			</div><!--/.titles -->

			<div class="span6">
				<div class="contact-form"><?php echo do_shortcode('[contact-form-7 id="68" title="Contact form"]');?></div>
			</div><!--/.span6 -->

			<div class="span6" data-animated="fadeInRight">
				<div class="content_contact_tb">
					<div class="content_contact"><?php the_content(); ?></div>
				</div>
			</div><!--/.span6-->
		<?php endwhile;wp_reset_postdata(); ?>
    </div><!--/.container -->
</section>
<!-- END: CONTACT PAGE -->

<!-- START JOURNAL SECTION -->
<section id="journal" class="section">
    <div class="container">
		<div class="titles">
			<i class="icon"></i>
			<h1>JOURNAL</h1>
		</div><!--/.titles -->
		<?php			
			$args=array(			  
			  'post_type' => 'post',
				'posts_per_page' => 1
			);
			$journal = new WP_Query( $args );		
			//var_dump($journal->posts[0]->ID);
		?>
		<?php while ( $journal->have_posts() ) : $journal->the_post(); ?>
			 <div class="span9">
				<div id="content_post">
					<div class="title_single_post"><?php the_time('d, F Y')?> :: <?php the_title() ?></div>
					<?php the_content(); ?>
				
					<!-- AddThis Button BEGIN -->
					<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
					<a class="addthis_button_pinterest_pinit" pi:pinit:layout="horizontal" pi:pinit:url="http://www.addthis.com/features/pinterest" pi:pinit:media="http://www.addthis.com/cms-content/images/features/pinterest-lg.png"></a>
					<a class="addthis_button_tweet"></a>
					</div>
					<script type="text/javascript">var addthis_config = {"data_track_addressbar":false};</script>
					<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-53045b893505a5bc&async=1"></script>
					<!-- AddThis Button END -->
				</div>
			 </div>
		<?php endwhile;wp_reset_postdata(); ?>
		
		<div class="span3">
			<div class="list_post_wrap">
				<h3>POSTS</h3>
				<ul class="list_journal">
					<?php 
						$args=array(			  
						  'post_type' => 'post'				
						);
						$list_journal = new WP_Query( $args );			
					?>
					<?php while ( $list_journal->have_posts() ) : $list_journal->the_post(); ?>
					 <li>
						:: <a class="item_<?php echo $post->post_name ?>" href="<?php the_permalink();?>" data="#!post/<?php echo $post->post_name ?>"><?php the_title() ?></a>
					 </li>
					<?php endwhile;wp_reset_postdata(); ?>
				</ul>
			</div>
		</div>
		
    </div><!--/.container -->
</section>
<!-- END JOURNAL SECTION -->


<?php get_footer(); ?>